-- round
Wired.Math.Round = function(value, precision)
  if (precision) then
    local multiple = math.pow(10, precision);
    return (math.floor(value * multiple + 0.5) / multiple);
  else
    return math.floor(value + 0.5);
  end
end

-- converts [-1, 1] to [0, 1]
Wired.Math.PositiveNormalization = function(value)
  return ((value + 1) / 2);
end

-- percentage change
Wired.Math.PercentageChange = function(value1, value2)
  return ((value2 - value1) / value1);
end

-- returns [-1, 1] for location in [0, boundary]
Wired.Math.RelativeLocation = function(location, boundary)
  return (math.min(boundary, math.max(0, location)) / boundary) * 2 - 1;
end

-- returns [lowerBound, upperBound] for value
Wired.Math.Restrict = function(value, lowerBound, upperBound)
  return math.min(upperBound, math.max(lowerBound, value));
end

-- average
Wired.Math.Average = function(value1, value2)
  return ((value1 + value2) / 2);
end
