Wired.Math.Types = class();

-- constants
Wired.Math.Types.Matrix = "matrix";
Wired.Math.Types.Vector = "vector";

-- type checking
function Wired.Math.Types.IsTable(value)
  return (type(value) == "table");
end

function Wired.Math.Types.IsType(value, type)
  local result = false;
  if (Wired.Math.Types.IsTable(value)) then
    if (value.type == type) then
      result = true;
    end
  end
  return result;
end

function Wired.Math.Types.IsMatrix(value)
  return Wired.Math.Types.IsType(value, Wired.Math.Types.Matrix);
end

function Wired.Math.Types.IsVector(value)
  return Wired.Math.Types.IsType(value, Wired.Math.Types.Vector);
end

-- type setting
function Wired.Math.Types.MakeType(value, type)
  if (Wired.Math.Types.IsTable(value)) then
    value.type = type;
  end
end

function Wired.Math.Types.MakeMatrix(value)
  Wired.Math.Types.MakeType(value, Wired.Math.Types.Matrix);
end

function Wired.Math.Types.MakeVector(value)
  Wired.Math.Types.MakeType(value, Wired.Math.Types.Vector);
end
