Wired.Math.Vector = class();

function Wired.Math.Vector:Constructor(table)
  Wired.Math.Types.MakeVector(self);
  self.size = #table;
  self.data = {};
  for i = 1, self.size do
    if (table[i]) then
      self.data[i] = table[i];
    else
      self.data[i] = 0;
    end
  end
end

function Wired.Math.Vector:String()
  local result = "";
  for i = 1, self.size do
    if (i > 1) then
      result = result .. " ";
    end
    result = result .. Wired.Math.Round(self.data[i], 2);
  end
  return ("[" .. result .. "]");
end

-- access methods
function Wired.Math.Vector:Get(index)
  return self.data[index];
end

-- manipulation
function Wired.Math.Vector:Dot(vector)
  Wired.Math.Vector.CompareSize(self, vector);
  local result = 0;
  for i = 1, self.size do
    result = result + self.data[i] * vector.data[i];
  end
  return result;
end

function Wired.Math.Vector:Multiply(value)
  for i = 1, self.size do
    self.data[i] = self.data[i] * value;
  end
end

function Wired.Math.Vector.CompareSize(v1, v2)
  assert(v1.size == v2.size, "Inconsistent vector sizes");
end
