-----------------------
-- Wired             --
-- By: Wire @ Byriel --
-----------------------

-- format
Wired.UI.Format = {};

-- constants
Wired.UI.Format.Constants = {
  Hitpoints = {
    Threshold = 1000,
    Unit = {
      "",
      "k",
      "m",
      "b"
    }
  },
  Time = {
    Threshold = 60,
    Unit = {
      "s",
      "m",
      "h"
    }
  }
};

-- format hitpoints
Wired.UI.Format.Hitpoints = function(value)
  
  -- result
  local result = value;
  
  -- index
  local index = 1;
  while (result >= Wired.UI.Format.Constants.Hitpoints.Threshold) do
    result = result / Wired.UI.Format.Constants.Hitpoints.Threshold;
    index = index + 1;
  end
  
  -- round
  result = Wired.Math.Round(result, 1);
  
  -- return
  return result .. Wired.UI.Format.Constants.Hitpoints.Unit[index];
end

-- format time
Wired.UI.Format.Time = function(value)
  
  -- result
  local result = value;
  
  -- index
  local index = 1;
  while (result >= Wired.UI.Format.Constants.Time.Threshold) do
    result = result / Wired.UI.Format.Constants.Time.Threshold;
    index = index + 1;
  end
  
  -- round
  result = Wired.Math.Round(result, 1);
  
  -- return
  return result .. Wired.UI.Format.Constants.Time.Unit[index];
end
