-----------------------
-- Wired             --
-- By: Wire @ Byriel --
-----------------------

Wired.UI.TextShadow = class(Wired.UI.Trion.Frame);

-- defaults
Wired.UI.TextShadow.Defaults = {
  Colors = {
    Background = Wired.UI.Color.Clear,
    Font = {
      LabelShadow = Wired.UI.Color.Black
    }
  },
  Offset = {
    Left = 1,
    Top = 1
  }
};

function Wired.UI.TextShadow:Constructor(name, parent)
  Wired.UI.Trion.Frame.Constructor(self, name, parent);
  
  -- create label shadow
  self:SetLabelShadow(Wired.UI.Trion.Text(self:GetName() .. "_LabelShadow", self));
  self:GetLabelShadow():SetPoint({child = "CENTER", parent = "CENTER"}, {x = Wired.UI.TextShadow.Defaults.Offset.Left, y = Wired.UI.TextShadow.Defaults.Offset.Top});
  self:GetLabelShadow():SetLayer(1);
  self:GetLabelShadow():SetVisible(true);
  
  -- create label
  self:SetLabel(Wired.UI.Trion.Text(self:GetName() .. "_Label", self));
  self:GetLabel():SetPoint({child = "CENTER", parent = "CENTER"}, {x = 0, y = 0});
  self:GetLabel():SetLayer(2);
  self:GetLabel():SetVisible(true);
  
  -- defaults
  self:ApplyTextShadowDefaults();
end

-- label shadow
function Wired.UI.TextShadow:GetLabelShadow()
  return self.labelShadow;
end

function Wired.UI.TextShadow:SetLabelShadow(value)
  self.labelShadow = value;
end

-- label
function Wired.UI.TextShadow:GetLabel()
  return self.label;
end

function Wired.UI.TextShadow:SetLabel(value)
  self.label = value;
end

-- text
function Wired.UI.TextShadow:GetText()
  return self:GetLabel():GetText();
end

function Wired.UI.TextShadow:SetText(value)
  self:GetLabelShadow():SetText(value);
  self:GetLabel():SetText(value);
end

-- font color
function Wired.UI.TextShadow:GetFontColor()
  return self:GetLabel():GetFontColor();
end

function Wired.UI.TextShadow:SetFontColor(value)
  self:GetLabel():SetFontColor(value);
end

-- font size
function Wired.UI.TextShadow:GetFontSize()
  return self:GetLabel():GetFontSize();
end

function Wired.UI.TextShadow:SetFontSize(value)
  self:GetLabelShadow():SetFontSize(value);
  self:GetLabel():SetFontSize(value);
end

-- layer
function Wired.UI.TextShadow:SetLayer(value)
  self:GetBase():SetLayer(value);
  self:GetLabelShadow():SetLayer(value + 1);
  self:GetLabel():SetLayer(value + 2);
end

-- width
function Wired.UI.TextShadow:SetWidth(value)
  self:GetBase():SetWidth(value);
  self:GetLabelShadow():SetWidth(value);
  self:GetLabel():SetWidth(value);
end

-- height
function Wired.UI.TextShadow:SetHeight(value)
  self:GetBase():SetHeight(value);
  self:GetLabelShadow():SetHeight(value);
  self:GetLabel():SetHeight(value);
end

-- metrics
function Wired.UI.TextShadow:GetFullWidth()
  return self:GetLabel():GetFullWidth();
end

function Wired.UI.TextShadow:GetFullHeight()
  return self:GetLabel():GetFullHeight();
end

-- wrap
function Wired.UI.TextShadow:GetWrapping()
  return self:GetLabel():GetWordwrap();
end

function Wired.UI.TextShadow:SetWrapping(value)
  self:GetLabelShadow():SetWordwrap(value);
  self:GetLabel():SetWordwrap(value);
end

-- defaults
function Wired.UI.TextShadow:ApplyTextShadowDefaults()
  
  -- color
  self:SetColor(Wired.UI.TextShadow.Defaults.Colors.Background);
  self:GetLabelShadow():SetColor(Wired.UI.TextShadow.Defaults.Colors.Background);
  self:GetLabel():SetColor(Wired.UI.TextShadow.Defaults.Colors.Background);
  
  -- font color
  self:GetLabelShadow():SetFontColor(Wired.UI.TextShadow.Defaults.Colors.Font.LabelShadow);
end

-- scale font size
function Wired.UI.TextShadow:ScaleFontSize()
  self:GetLabelShadow():ScaleFontSize();
  self:GetLabel():ScaleFontSize();
end
